Build:
  stage: Build
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-build-image:v0.4.0"
  variables:
    DOCKER_TLS_CERTDIR: ""
  services:
    - docker:19.03.12-dind
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: never
    - if: '$CI_COMMIT_BRANCH =~ /^test-.*/ || $CI_COMMIT_BRANCH =~ /^nocicd-.*/'
      when: never
    - if: '$CI_PIPELINE_SOURCE == "push" || $CI_PIPELINE_SOURCE == "web"'
  before_script:
    - |
      if ! docker info &>/dev/null; then
        if [ -z "$DOCKER_HOST" ] && [ "$KUBERNETES_PORT" ]; then
          export DOCKER_HOST='tcp://localhost:2375'
        fi
      fi
    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG}
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_SHA}
        export builder_image=$CI_APPLICATION_REPOSITORY:$CI_COMMIT_REF_NAME-builder
      else
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE}
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_TAG}
        export builder_image=$CI_APPLICATION_REPOSITORY:builder
      fi
    - export main_builder_image=$CI_APPLICATION_REPOSITORY:builder
    - export image_previous="$CI_APPLICATION_REPOSITORY:$CI_COMMIT_BEFORE_SHA"
    - export image_tagged="$CI_APPLICATION_REPOSITORY:$CI_APPLICATION_TAG"
    - export image_latest="$CI_APPLICATION_REPOSITORY:latest"
  script:
    - |
      if [[ -n "$CI_REGISTRY" && -n "$CI_REGISTRY_USER" ]]; then
        echo "Logging to GitLab Container Registry with CI credentials..."
        echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin "$CI_REGISTRY"
      fi

    ### Pulling prebuilt images
    - |
      if DOCKER_CLI_EXPERIMENTAL=enabled docker manifest inspect $builder_image > /dev/null; then
        echo "Pull prebuilded (branch) image"
        docker image pull --quiet $builder_image
      else
        if DOCKER_CLI_EXPERIMENTAL=enabled docker manifest inspect $main_builder_image > /dev/null; then
          echo "Pull prebuilded (main) image"
          docker image pull --quiet $main_builder_image
        fi
      fi

    ### Using Dockerfile for branch
    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        echo "Selected Dockerfile is Review"
        mv .cicd/docker/Dockerfile.review ./Dockerfile
      else
        echo "Selected Dockerfile is Production"
        mv .cicd/docker/Dockerfile ./Dockerfile
      fi

    ### Build builder image
    - |
      docker build \
        --cache-from=$builder_image \
        --target builder \
        --tag $builder_image \
        .
    - docker push $builder_image

    ### Build executable image
    - |
      docker build \
        --cache-from=$builder_image \
        --build-arg CI_APPLICATION_TAG=$CI_APPLICATION_TAG \
        --build-arg CI_PROJECT_NAME=$CI_PROJECT_NAME \
        --tag $image_tagged \
        --tag $image_latest \
        .

    - docker push $image_latest
    - docker push $image_tagged

    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        export SENTRY_MESSAGE="{\"version\": \"$CI_COMMIT_SHA\",\"refs\": [{\"repository\":\"$CI_SENTRY_REPOSITORY\",\"commit\":\"$CI_COMMIT_SHA\",\"previousCommit\":\"$CI_COMMIT_BEFORE_SHA\"}],\"projects\":[\"$CI_SENTRY_PROJECT\"]}"
      else
        export SENTRY_MESSAGE="{\"version\": \"$CI_COMMIT_TAG\",\"refs\": [{\"repository\":\"$CI_SENTRY_REPOSITORY\",\"commit\":\"$CI_COMMIT_SHA\"}],\"projects\":[\"$CI_SENTRY_PROJECT\"]}"
      fi
    - |
      apk add curl
      curl https://sentry.iilab.ru/api/0/organizations/sentry/releases/ \
        -X POST \
        -H 'Authorization: Bearer $CI_SENTRY_TOKEN' \
        -H 'Content-Type: application/json' \
        -d "$SENTRY_MESSAGE"

